## ros-foxy-image-transport 2.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(image_transport)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(message_filters REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)

include_directories(include)

# Build image_transport library
add_library(${PROJECT_NAME}
  src/camera_common.cpp
  src/publisher.cpp
  src/subscriber.cpp
  src/single_subscriber_publisher.cpp
  src/camera_publisher.cpp
  src/camera_subscriber.cpp
  src/image_transport.cpp
)

ament_target_dependencies(
  ${PROJECT_NAME}
  message_filters
  pluginlib
  rclcpp
  sensor_msgs
)

target_compile_definitions(${PROJECT_NAME} PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_compile_definitions(${PROJECT_NAME} PRIVATE "IMAGE_TRANSPORT_BUILDING_DLL")

# Build image_transport_plugins library (raw)
add_library(${PROJECT_NAME}_plugins
  src/manifest.cpp
)
target_link_libraries(${PROJECT_NAME}_plugins ${PROJECT_NAME})

# Build list_transports
add_executable(list_transports src/list_transports.cpp)
target_link_libraries(list_transports ${PROJECT_NAME})

# Build republish
add_executable(republish src/republish.cpp)
target_link_libraries(republish ${PROJECT_NAME})

# Install plugin descriptions
pluginlib_export_plugin_description_file(image_transport default_plugins.xml)

# Install libraries
install(
  TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_plugins
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# Install executables
install(
  TARGETS list_transports republish
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include directories
install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_export_dependencies(message_filters rclcpp sensor_msgs pluginlib)

if(BUILD_TESTING)
  #TODO(ros2) enable linting
  #find_package(ament_lint_auto REQUIRED)
  #ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest)

  ament_add_gtest(${PROJECT_NAME}-camera_common test/test_camera_common.cpp)
  if(TARGET ${PROJECT_NAME}-camera_common)
    target_link_libraries(${PROJECT_NAME}-camera_common ${PROJECT_NAME})
  endif()

  ament_add_gtest(${PROJECT_NAME}-publisher test/test_publisher.cpp)
  if(TARGET ${PROJECT_NAME}-publisher)
    target_link_libraries(${PROJECT_NAME}-publisher ${PROJECT_NAME})
  endif()

  ament_add_gtest(${PROJECT_NAME}-subscriber test/test_subscriber.cpp)
  if(TARGET ${PROJECT_NAME}-subscriber)
    target_link_libraries(${PROJECT_NAME}-subscriber ${PROJECT_NAME})
  endif()

  ament_add_gtest(${PROJECT_NAME}-message_passing test/test_message_passing.cpp)
  if(TARGET ${PROJECT_NAME}-message_passing)
    target_link_libraries(${PROJECT_NAME}-message_passing ${PROJECT_NAME})
  endif()

  ament_add_gtest(${PROJECT_NAME}-remapping test/test_remapping.cpp)
  if(TARGET ${PROJECT_NAME}-remapping)
    target_link_libraries(${PROJECT_NAME}-remapping ${PROJECT_NAME})
  endif()

  ament_add_gtest(${PROJECT_NAME}-single_subscriber_publisher test/test_single_subscriber_publisher.cpp)
  if(TARGET ${PROJECT_NAME}-single_subscriber_publisher)
    target_link_libraries(${PROJECT_NAME}-single_subscriber_publisher ${PROJECT_NAME})
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-foxy-image-transport (2.4.0-1focal) focal; urgency=high

  * getNumSubscribers working method to foxy (#220 <https://github.com/ros-perception/image_common/issues/220>)
  * Simple IT plugins shutdown (#225 <https://github.com/ros-perception/image_common/issues/225>) (#230 <https://github.com/ros-perception/image_common/issues/230>)
  * Contributors: Michael Ferguson, Alejandro Hernández Cordero, vladimirilin, Matej Vargovcik, RoboTech Vision

 -- Michael Carroll <michael@openrobotics.org>  Tue, 12 Jul 2022 00:00:00 -0000

ros-foxy-image-transport (2.3.0-1focal) focal; urgency=high

  * Fix formatting and include paths for linters (#157 <https://github.com/ros-perception/image_common/issues/157>)
  * Fix QoS initialization from RMW QoS profile (#158 <https://github.com/ros-perception/image_common/issues/158>)
  * Contributors: Jacob Perron, Martin Idel

 -- Michael Carroll <michael@openrobotics.org>  Wed, 27 May 2020 00:00:00 -0000

ros-foxy-image-transport (2.2.1-1focal) focal; urgency=high

  * add missing set header (#140 <https://github.com/ros-perception/image_common/issues/140>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-image-transport (2.2.0-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 27 Sep 2019 00:00:00 -0000

ros-foxy-image-transport (2.1.1-1focal) focal; urgency=high

  * Update to use new count APIs (#128 <https://github.com/ros-perception/image_common/issues/128>)
  * use latest ros2 API (#127 <https://github.com/ros-perception/image_common/issues/127>)
  * Contributors: Karsten Knese, Michael Carroll

 -- Michael Carroll <michael@openrobotics.org>  Thu, 30 May 2019 00:00:00 -0000

ros-foxy-image-transport (2.1.0-1focal) focal; urgency=high

  * Update ROS2 branch to account for new NodeOptions interface (#120 <https://github.com/ros-perception/image_common/issues/120>)
  * Contributors: Carl Delsey

 -- Michael Carroll <michael@openrobotics.org>  Thu, 09 May 2019 00:00:00 -0000

ros-foxy-image-transport (2.0.0-1focal) focal; urgency=high

  * camera_info_manager ROS2 port (#94 <https://github.com/ros-perception/image_common/issues/94>)
  * Pointer api updates (#104 <https://github.com/ros-perception/image_common/issues/104>)
  * Fix rcutils API change by just removing it. (#103 <https://github.com/ros-perception/image_common/issues/103>)
  * [ROS2] corrections to remapping for raw images (#97 <https://github.com/ros-perception/image_common/issues/97>)
  * Make ROS2 ImageTransport conform to old api (#88 <https://github.com/ros-perception/image_common/issues/88>)
  * Image Transport ROS2 Port (#84 <https://github.com/ros-perception/image_common/issues/84>)
  * Contributors: Michael Carroll

 -- Michael Carroll <michael@openrobotics.org>  Wed, 05 Dec 2018 00:00:00 -0000

ros-foxy-image-transport (1.11.13-1focal) focal; urgency=high

  * Disable image publisher plugins by name (#60 <https://github.com/ros-perception/image_common/issues/60>)
    * Disable publisher plugins by name
    * Now have per publisher blacklist instead of image_transport wide.
  * update to use non deprecated pluginlib macro
  * Extend documentation of getCameraInfoTopic
    Document the fact that the base_topic argument must be resolved in order to build the correct camera info topic.
  * Added cv::waitkey(10) for blank popup
    Without the cv::waitkey(10), it results in a blank popup which crashes/ leads to a black popup. This change corrects that problem.
    ROS Kinetic, Ubuntu 16.04.3
  * Contributors: Aaditya Saraiya, Lucas Walter, Mikael Arguedas, Thibaud Chupin, Vincent Rabaud

 -- Michael Carroll <michael@openrobotics.org>  Sun, 05 Nov 2017 00:00:00 -0000

ros-foxy-image-transport (1.11.12-1focal) focal; urgency=high

  * Fix CMake of image_transport/tutorial and polled_camera
    Fix loads of problems with the CMakeLists.
  * image_transport/tutorial: Add dependency on generated msg
    Without this, build fails on Kinetic because ResizedImage.h has not been
    generated yet.
  * image_transport/tutorial: Add missing catkin_INCLUDE_DIRS
    Without this, compilation files on Kinetic because ros.h cannot be found.
  * 1.11.11
  * update changelogs
  * Contributors: Martin Guenther, Vincent Rabaud

 -- Michael Carroll <michael@openrobotics.org>  Sun, 29 Jan 2017 00:00:00 -0000

ros-foxy-image-transport (1.11.11-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Sat, 24 Sep 2016 00:00:00 -0000

ros-foxy-image-transport (1.11.10-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 19 Jan 2016 00:00:00 -0000

ros-foxy-image-transport (1.11.9-1focal) focal; urgency=high

  * fix linkage in tutorials
  * Use $catkin_EXPORTED_TARGETS
  * Contributors: Jochen Sprickerhof, Vincent Rabaud

 -- Michael Carroll <michael@openrobotics.org>  Sun, 17 Jan 2016 00:00:00 -0000

ros-foxy-image-transport (1.11.8-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Sun, 29 Nov 2015 00:00:00 -0000

ros-foxy-image-transport (1.11.7-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 28 Jul 2015 00:00:00 -0000

ros-foxy-image-transport (1.11.6-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 16 Jul 2015 00:00:00 -0000

ros-foxy-image-transport (1.11.5-1focal) focal; urgency=high

  * image_transport: fix CameraSubscriber shutdown (circular shared_ptr ref)
    CameraSubscriber uses a private boost::shared_ptr to share an impl object
    between copied instances. In CameraSubscriber::CameraSubscriber(), it
    handed this shared_ptr to boost::bind() and saved the created wall timer
    in the impl object, thus creating a circular reference. The impl object
    was therefore never freed.
    Fix that by passing a plain pointer to boost::bind().
  * avoid a memory copy for the raw publisher


=== debian/control ===
Source: ros-foxy-image-transport
Section: misc
Priority: optional
Maintainer: Michael Carroll <michael@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-gtest, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-message-filters, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Homepage: http://ros.org/wiki/image_transport
Standards-Version: 3.9.2

Package: ros-foxy-image-transport
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-message-filters, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Description: image_transport should always be used to subscribe to and publish images.
 It provides transparent support for transporting images in low-bandwidth compressed formats. Examples (provided by separate plugin packages) include JPEG/PNG compression and Theora streaming video.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-image-transport//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
